         .include "ti-86.h"

score    =$c0f9         ; the score!
edgedata =$c101
v        =$c137
destroy  =$c138
x        =$c13a

 ; -------------- LOAD / UNLOAD ---------------------------------------------
         call     _clrLCD
         ld       hl,0
         ld       ($c00f),hl
         ld       hl,title_message
         call     _puts

loopttl: call     _getkey
         cp       kF1
         jr       z,speed_1
         cp       kF2
         jr       z,speed_2
         cp       kF3
         jr       z,speed_3
         cp       kF4
         jr       z,speed_4
         cp       kF5
         jr       z,speed_5
         cp       kExit
         jr       nz,loopttl
         ret
title_message:                 
         .db      "Z-Kart 3D        v1.0"
         .db      " by Patrick Davidson "
         .db      "  (ariwsi@juno.com)  "
         .db      "Choose Speed : F1-F5",0
speed_1: ld       hl,0
         ld       de,500
         jr       start
speed_2: ld       hl,50
         ld       de,400
         jr       start
speed_3: ld       hl,100
         ld       de,300
         jr       start
speed_4: ld       hl,150
         ld       de,200
         jr       start
speed_5: ld       hl,200
         ld       de,100
start:   ld       (score),hl
         ld       (loop+1),de
 ; -------------- ACTUAL GAME ----------------------------------------------
         call     _clrLCD
         ld       hl,$0007
         ld       ($c00f),hl
         ld       hl,message
         call     _puts
         ld       hl,edgedata
         ld       b,54
lced:    ld       (hl),45
         inc      hl
         djnz     lced
 ; -------------- MAIN LOOP ------------------------------------------------
loop:    ld       bc,0
wait:    dec      bc
         ld       a,b
         or       c
         jr       nz,wait
 ; -------------- RENDER THE TRACK -----------------------------------------
         ld       a,(marker)
         dec      a
         jr       nz,n0
         ld       a,9
n0:      ld       (marker),a
         ld       hl,$fc00
         ld       (destroy),hl
         LD       HL,edgedata
         ld       b,9
         ld       c,-1
render_far_away:
         call     linedrw
         inc      hl
         djnz     render_far_away
         ld       b,9
render_middle_distance:
         call     linedrw
         dec      hl
         call     linedrw
         inc      hl
         djnz     render_middle_distance
         ld       b,9
render_near:
         call     linedrw
         dec      hl
         call     linedrw
         dec      hl
         call     linedrw
         inc      hl
         djnz     render_near
         ld       b,63
 ; -------------- UPDATE SCORE ----------------------------------------------
         LD       HL,$1007
         ld       ($c00f),hl
         ld       hl,(score)
         inc      hl
         ld       (score),hl
         call     D_HL_DECI
 ; -------------- MOVE UP THE LANDSCAPE -------------------------------------
         ld       a,r
         cp       8
         jr       NC,nocc
         ld       hl,dirs
         and      7
         ld       e,a
         ld       d,0
         ADD      hl,de
         ld       a,(hl)
         ld       (v),a
nocc:    ld       de,edgedata+53
         ld       hl,edgedata+51
         ld       bc,52
         lddr
         inc      hl
         inc      de
         ld       a,(v)
         ld       d,a
         ld       a,(hl)
         cp       60
         jr       nz,nle
         ld       d,1
nle:     inc      hl
         ld       a,(hl)
         cp       60
         jr       nz,nre
         ld       d,-1
nre:     ld       a,d
         ld       (v),a
         ld       a,(hl)
         add      a,d
         ld       (hl),a
         dec      hl
         ld       a,(hl)
         sub      d
         ld       (hl),a
         LD       A,(score)
         and      15
         jr       nz,ntts
         dec      (hl)
         inc      hl
         dec      (hl)
         ld       hl,(loop+1)
         dec      hl
         ld       a,h
         or       l
         jr       z,ntts
         ld       (loop+1),hl
ntts:
 ; -------------- MOVE YOUR CAR ---------------------------------------------
         ld       a,%01111110
         out      (1),a
         ld       hl,x
         in       a,(1)
         rra
         rra
         jr       c,noleft
         dec      (hl)
         dec      (hl)
noleft:  rra
         jr       c,noright
         inc      (hl)
         inc      (hl)
noright: ld       a,(hl)
         ld       c,53
         call     pton
         ld       a,(hl)
         dec      a
         call     pton
         ld       a,(hl)
         inc      a
         call     pton
         ld       a,(hl)
         inc      a
         inc      a
         call     pton
         ld       a,(hl)
         dec      a
         dec      a
         call     pton
         dec      c
         ld       a,(hl)
         call     pton
         ld       a,(hl)
         dec      a
         call     pton
         ld       a,(hl)
         inc      a
         call     pton
         ld       a,(hl)
         dec      c
         call     pton
         ld       a,%00111111
         out      (1),a
         in       a,(1)
         bit      6,a
         ret      z
 ; -------------- SEE IF YOU LOSE ------------------------------------------
         ld       a,(x)
         ld       hl,edgedata+53
         add      a,2
         sub      (hl)
         jp       p,lose
         dec      hl
         ld       a,(x)
         sub      2
         add      a,(hl)
         jp       p,loop
 ; -------------- GAME OVER ------------------------------------------------
lose:    ld       hl,0
         ld       ($c00f),hl
         ld       hl,lose_
         call     _puts
lwk:     call     _getkey
         cp       kEnter
         jr       nz,lwk
         ret
 ; -------------- DATA / SUBROUTINES ----------------------------------------
lose_:   .db      "LOSER!!!  Press ENTER",0
message: .db      "Z-Kart 3D Score:"
         .db      0
linedrw:
         inc      c
         push     hl                ;save coordinate pointer
         push     bc
         ld       bc,15
         ld       HL,(destroy)
         ld       (hl),0
         ld       de,(destroy)
         inc      de
         ldir
         ld       (destroy),de
         pop      bc
         pop      hl
         ld       a,(marker)
         cp       b
         jr       nz,nad
         inc      hl
         ld       a,(hl)
         dec      hl
         sub      (hl)
         sra      a
         call     DoConvSide
         call     pton        
nad:     ld       a,(hl)
         inc      hl
         call     DoConvSide
         neg                        ;Flip to left side
         call     pton              ;Plot this pixel
         LD       A,(HL)            ;read right edge coordinate
         call     DoConvSide
pton:    push     hl
         push     bc
         add      a,63
         ld       b,a
         call     FIND_PIXEL        ;Get the pixel offset
         ld       hl,$FC00
         add      hl,de             ;Point into the graphics memory
         or       (HL)              ;A now contains the modified screen byte
         ld       (HL),A            ;Write back to screen to update
         pop      bc
         pop      hl
         ret
DoConvSide:
         push     hl
         ld       hl,clab1
         bit      7,a
         jr       nz,dcs_neg
         ld       (hl),$c9
dcs_c:   LD       DE,20
         call     MUL_A_DE     
         ld       a,74
         sub      c             
         call     UNPACKHL+2    
         ld       a,l
         pop      hl
clab1:   neg
         ret
dcs_neg: neg
         ld       (hl),$ed
         jr       dcs_c

dirs:    .db      1,0,-1,1,-1,1,0,-1
marker:  .db      4
end:     .end
